#pragma once

#include <map>
#include <mutex>

#include "accessor.h"
#include "page_mapper.h"



/* Mapping type from accessors to page mappers. */

typedef std::map<Accessor *, PageMapper *> AccessorMapping;
typedef std::pair<Accessor *, PageMapper *> AccessorMappingEntry;



/* A registry of mappers for accessors. */

class Paging
{
protected:
    AccessorMapping _mappers;
    std::mutex _lock;

public:
    bool reserve(Accessor *accessor);

    PageMapper *get(Accessor *accessor);

    void set(Accessor *accessor, PageMapper *mapper);
};

// vim: tabstop=4 expandtab shiftwidth=4
